#include "DxLib.h"
#include "struct.h"
#include "KEY.h"
#include "HIT.h"
#include "MAP.h"
#include "Player.h"
#include "effect.h"

c_PLAYER Player;
////////////////////////////////////////////////////////////////////
int c_PLAYER::H_food1(void){
		Ball2D food1	=	R_food1();
		for(int i=0;i<MAP_LINE_MAX;i++){
			if(	Hit.HitBallLine(food1,Map.R_Line(i))	){
				return 1;
			}
		}
	return 0;
}
int c_PLAYER::H_food2(void){
		Ball2D food2	=	R_food2();
		for(int i=0;i<MAP_LINE_MAX;i++){
			if(	Hit.HitBallLine(food2,Map.R_Line(i))	){
				return 1;
			}
		}
	return 0;
}
int c_PLAYER::H_food(void){
	if(H_food1()==1 || H_food2()==1)
		return 1;
	return 0;
}
///////////////////////////////////////////////////////////////////
void c_PLAYER::M_Init(void){
	body.x	=	0;
	body.y	=	-25;
	body.r	=	25;
	food1.x	=	12;
	food1.y	=	60-19;
	food1.r	=	10;
	food2.x	=	-12;
	food2.y	=	60-19;
	food2.r	=	10;

/*POSE_LFET_STOP*/
	Motion[POSE_LEFT_STOP].Speed	=0.03;
	Motion[POSE_LEFT_STOP].Max		=1;
/*POSE_LFET_RUN*/
	Motion[POSE_LEFT_RUN].Speed	=0.06;
	Motion[POSE_LEFT_RUN].Max	=2;
/*POSE_LFET_ATTACK*/
	Motion[POSE_LEFT_ATTACK].Speed	=0.06;
	Motion[POSE_LEFT_ATTACK].Max	=2;

/*POSE_RIGHT_STOP*/
	Motion[POSE_RIGHT_STOP].Speed	=0.03;
	Motion[POSE_RIGHT_STOP].Max		=1;
/*POSE_RIGHT_RUN*/
	Motion[POSE_RIGHT_RUN].Speed=0.06;
	Motion[POSE_RIGHT_RUN].Max	=2;
/*POSE_LFET_ATTACK*/
	Motion[POSE_RIGHT_ATTACK].Speed	=0.06;
	Motion[POSE_RIGHT_ATTACK].Max	=2;
}
void c_PLAYER::M_Count(void){
	MotionCount += Motion[Pose].Speed;
	if(Motion[Pose].Max <= (int)MotionCount){
		MotionCount=0.0;
		if(Pose==POSE_LEFT_ATTACK)PoseChange(POSE_LEFT_STOP);
		if(Pose==POSE_RIGHT_ATTACK)PoseChange(POSE_RIGHT_STOP);
	}
}
Ball2D c_PLAYER::R_body(void){
	Ball2D Ball;
	Ball.x	=	Point.x+body.x;
	Ball.y	=	Point.y+body.y;
	Ball.r	=	body.r;
	return Ball;
}
Ball2D c_PLAYER::R_food1(void){
	Ball2D Ball;
	Ball.x	=	Point.x+food1.x;
	Ball.y	=	Point.y+food1.y;
	Ball.r	=	food1.r;
	return Ball;
}
Ball2D c_PLAYER::R_food2(void){
	Ball2D Ball;
	Ball.x	=	Point.x+food2.x;
	Ball.y	=	Point.y+food2.y;
	Ball.r	=	food2.r;
	return Ball;
}
///////////////////////////////////////////////////////////////////
void c_PLAYER::PoseChange(POSE data){
	if(Pose != data){
		MotionCount	=	0.0;
		Pose		=	data;
	}
}
///////////////////////////////////////////////////////////////////
void c_PLAYER::P_Init(void){
	SetPoint(100.0,100.0);
	Pose	=	POSE_RIGHT_STOP	;
	JumpMax		=1;
	JumpCount	=0;
	JumpPower	=-5.7;
}
//PAKO0621_摜̃[h
void c_PLAYER::P_ImgLode(void){
    PlayerImg[POSE_LEFT_STOP];
    PlayerImg[POSE_LEFT_RUN];
    PlayerImg[POSE_LEFT_ATTACK];
}
////////////////////////////////////////////////////////////////////
//W𓮂B
void c_PLAYER::Movement(void){
	if(H_food())printfDx("ĂɂړO\n");
	int FFx=0,
		FFy=0;
/*XẄړ*/
	float speedX=Speed.x+TempSpeed.x;
	Point.x+=speedX;
	if(H_food()==1){
		TempSpeed.y-=1.1;
		do{
			if(speedX<0)	Point.x+=0.1;
			else if(0<speedX)Point.x-=0.1;
			else break;
		}while(H_food()==1);
	}
/*YẄړ*/
	float speedY=Speed.y+TempSpeed.y;
	Point.y+=speedY;
	if(H_food()==1){
		if(0<speedY)JumpCount=0;
		Speed.y=0.0;
		do{
			if(speedY<0)	Point.y+=0.1;
			else if(0<speedY)Point.y-=0.1;
			else break;
		}while(H_food()==1);
	}

	TempSpeed.x=0.0;
	TempSpeed.y=0.0;

	if(H_food())printfDx("ĂɂړI\n");
}
////////////////////////////////////////////////////////////////////
void c_PLAYER::InputMove(void){
	float speed=0.4;
	/*	Eւ̈ړ	*/
	int LEFT	=Key.KeyGet(INPUT_LEFT),	//͏Ԃۑ
		RIGHT	=Key.KeyGet(INPUT_RIGHT);	//͏Ԃۑ
	/*ړ*/
	if(Pose==POSE_LEFT_STOP || Pose==POSE_LEFT_RUN ||Pose==POSE_RIGHT_STOP || Pose==POSE_RIGHT_RUN){
		/*ړ*/
		if(0<LEFT	&& RIGHT<=LEFT){	//{^ĂȂ
			Speed.x	-=	speed;			//ֈړ
			PoseChange(POSE_LEFT_RUN);	//|[YύX
/*			if(LEFT%10==1){
				Ball2D BallFood1=R_food2();
				Effect.Set(1,(int)BallFood1.x,(int)BallFood1.y);
			}*/
		}
		/*Eړ*/
		if(0<RIGHT	&& LEFT<RIGHT){		//E{^ĂȂ
			Speed.x	+=	speed;			//Eֈړ
			PoseChange(POSE_RIGHT_RUN);	//|[YύX
/*			if(RIGHT%10==1){
				Ball2D BallFood1=R_food1();
				Effect.Set(EFE_DATA_fire01,(int)BallFood1.x,(int)BallFood1.y);
			}*/
		}
	}
	/*ǂɂړĂȂꍇ*/
	if((LEFT==0 && RIGHT==0)){
		Speed.x	=0;
		if(Pose == POSE_RIGHT_RUN)PoseChange(POSE_RIGHT_STOP);
		if(Pose == POSE_LEFT_RUN)PoseChange(POSE_LEFT_STOP);
	}
	/*̒*/
	if(Speed.x < -3.5 ){Speed.x=-3.5;}
	if(3.5 < Speed.x){Speed.x=3.5;}
	/*U{^Ȃ*/
	if(Key.KeyGet(INPUT_A)==1){
		if(Pose==POSE_LEFT_STOP || Pose==POSE_LEFT_RUN)PoseChange(POSE_LEFT_ATTACK);	//|[YύX
		if(Pose==POSE_RIGHT_STOP || Pose==POSE_RIGHT_RUN)PoseChange(POSE_RIGHT_ATTACK);	//|[YύX
/*		Ball2D BallFood1=R_body();
		Effect.Set(EFE_DATA_kiba01,(int)BallFood1.x,(int)BallFood1.y);*/
	}
	/*Wvɂ*/
	int UP	=Key.KeyGet(INPUT_B);		//͂ۑ
	if(Speed.y < 8.5)Speed.y	+=	0.1;//d
	if(UP == 1 && JumpCount<JumpMax){	//͂ĂăWv񐔂ĂȂꍇ
		JumpCount++;					//Wv񐔂̃JEg
		Speed.y =	JumpPower;			//Wv
		/*Ball2D BallFood1=R_food1();
		Effect.Set(EFE_DATA_wind01,(int)BallFood1.x,(int)BallFood1.y);*/
	}
}
////////////////////////////////////////////////////////////////////
//XWZbgB
void c_PLAYER::SetPointX(float X){
	Point.x=X;
}
//YWZbgB
void c_PLAYER::SetPointY(float Y){
	Point.y=Y;
}
//WZbgB
void c_PLAYER::SetPoint(float X,float Y){
	SetPointX(X);
	SetPointY(Y);
}
/////////////////////////////////////////////////////////////////////////
//XړʂZbgB
void c_PLAYER::SetSpeedX(float X){
	Speed.x=X;
}
//YړʂZbgB
void c_PLAYER::SetSpeedY(float Y){
	Speed.y=Y;
}
//ړʂZbgB
void c_PLAYER::SetSpeed(float X,float Y){
	SetSpeedX(X);
	SetSpeedY(Y);
}
///////////////////////////////////////////////////////////////////////////
//xW𓾂
float c_PLAYER::R_PointX(void){
	return Point.x;
}
//yW𓾂
float c_PLAYER::R_PointY(void){
	return Point.y;
}
//W𓾂
Point2D c_PLAYER::R_Point(void){
	return Point;
}
///////////////////////////////////////////////////////////////////////
//ẍړʂ𓾂
float c_PLAYER::R_SpeedX(void){
	return Speed.x;
}
//ÿړʂ𓾂
float c_PLAYER::R_SpeedY(void){
	return Speed.y;
}
//ړʂ𓾂
Point2D c_PLAYER::R_Speed(void){
	return Speed;
}
////////////////////////////////////////////////////////////////////////
//݂̃|[Y𓾂
POSE c_PLAYER::R_POSE(void){
	return Pose;
}
//݂̃[V𓾂
int c_PLAYER::R_Motion(void){
	return (int)(MotionCount);
}
///////////////////////////////////












